#include "stdafx.h"
#include <set>
#include "BuddyList.h"

//////////////////////////////////////////////////////////////////////////////////////////////

CUserInfo::CUserInfo()
{
}

CString CUserInfo::GetMsgHeader(CString &strTo)
{
    TCHAR szTime[100];
    SYSTEMTIME st;
	::GetLocalTime(&st);
    ::GetTimeFormat(LOCALE_SYSTEM_DEFAULT,TIME_FORCE24HOURFORMAT|TIME_NOTIMEMARKER,&st,NULL,szTime,99);
    CString strTime = szTime;
    return CString(L"\n ")+strTime+CString(L" ")+*this+CString(L" >> ")+strTo+CString(" \n");
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CBuddyList::GetBuddyList(CArray<CString, CString &> &arNames, CString &strBuddy)
{
    m_BuddyList.clear();
    ResetContent();
    for(int i=0; i<arNames.GetCount(); ++i)
    {
        std::set<CString>::iterator iterSearch = m_BuddyList.find(arNames[i]);
        if (iterSearch==m_BuddyList.end())
        {
            m_BuddyList.insert(arNames[i]);
            AddString(arNames[i]);
        }
    }
    for(std::set<CString>::const_iterator iter = m_GuestList.begin(); iter!=m_GuestList.end(); ++iter)
    {
        std::set<CString>::iterator iterSearch = m_BuddyList.find(*iter);
        if (iterSearch==m_BuddyList.end())
        {
            AddString(*iter);
        }
    }
    SetSelBuddy(strBuddy);
}

int CBuddyList::SetSelBuddy(CString &strBuddy)
{
    int index = SelectString(0,strBuddy);
    if (index==CB_ERR)
    {
        SetCurSel(0);
        GetSelBuddy(strBuddy);
        index = 0;
    }
    return index;
}

void CBuddyList::GetSelBuddy(CString &strBuddy)
{
    int index = GetCurSel();
    if (index!=CB_ERR)
    {
        GetLBText(index, strBuddy);
    }
}

int CBuddyList::IncomingChatMessage(CString &strBuddy)
{
    if (!strBuddy.Trim().IsEmpty())
    {
        if (m_BuddyList.find(strBuddy)==m_BuddyList.end())
        {
            m_GuestList.insert(strBuddy);
        }
        return SetSelBuddy(strBuddy);
    }
    return CB_ERR;
}
