#if !defined(AFX_CLMGREVENTSINK_H__3ED66D51_DAF2_4980_84F9_4933652A7460__INCLUDED_)
#define AFX_CLMGREVENTSINK_H__3ED66D51_DAF2_4980_84F9_4933652A7460__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CLMgrPub.h"
#include "CLMgrPubTypes.h"
/////////////////////////////////////////////////////////////////////////////

extern const IID IID_IClientLineMgrEventsDisp;

/////////////////////////////////////////////////////////////////////////////

class CClientChat : public CCmdTarget
{
private:
    CComPtr< IClientLineMgrPub >  m_IClientLineMgrPub;
    CComPtr< IClientLineMgrPub5 > m_IClientLineMgrPub5;
    DWORD m_dwChatMessageReaderId;
    DWORD m_dwChatMessageWriterId;
    DWORD m_adviseCookie;
    void (*m_pfnCallback)(DWORD dwCookie, long msg, long param);
    DWORD m_dwCookie;

public:
	DECLARE_DYNCREATE(CClientChat)

	CClientChat();           // protected constructor used by dynamic creation
    void    SetCallbackFunction(void (*pfnCallback)(DWORD dwCookie, long msg, long param), DWORD dwCookie);
    HRESULT Register();
    HRESULT Unregister();
    HRESULT Advise();
    HRESULT Unadvise();
    HRESULT GetSpeedDial(int Index, CString &strName);
    HRESULT GetSpeedDials(CArray<CString, CString&> &arNames);
    HRESULT SendMessage(CString &strName, CByteArray &arInput);
    HRESULT ReadMessage(CString &strBuddy, CByteArray &arOutput);
    HRESULT GetLogonInfo(CString &strServer, CString &strUser);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClientChat)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
	virtual ~CClientChat();

	// Generated message map functions
	//{{AFX_MSG(CClientChat)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CClientChat)
	afx_msg void DispOnLineMgrNotification(long msg, long param);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLMGREVENTSINK_H__3ED66D51_DAF2_4980_84F9_4933652A7460__INCLUDED_)
