#pragma once

class CTracker : public CImageList
{
private:
    CRect m_rcSize;
    int m_iPos;

public:
	CTracker();
	virtual ~CTracker();
    void DrawGripper(CDC *pDC)
    {
        Draw(pDC, 0, CPoint(m_rcSize.left+m_rcSize.Width()/2-17,m_iPos-1),ILD_NORMAL);
    }
    int SetSize(CRect &rcSize, int iMinPos, int iMaxPos)
    {
        m_iPos = MulDiv(m_iPos,rcSize.Height(),m_rcSize.Height());
        if (m_iPos>iMaxPos)
            m_iPos = iMaxPos;
        else if (m_iPos<iMinPos)
            m_iPos = iMinPos;
        m_rcSize = rcSize;
        return m_iPos;
    }
    void SetPos(int iPos, CRect &rcSize)
    {
        m_iPos = iPos;
        m_rcSize = rcSize;
    }
    int GetPos()
    {
        return m_iPos;
    }
    bool HitTest(CPoint pt)
    {
        return CRect(m_rcSize.left,m_iPos-2,m_rcSize.right,m_iPos+2).PtInRect(pt);
    }
    HCURSOR LoadCursor()
    {
        return AfxGetApp()->LoadCursor(IDC_CURSORVSPLIT);
    }
    void DrawTrackRect(CDC *pDC, int y);
    int Track(CWnd* pWnd, CRect &rcClip);
};
