#pragma once

///////////////////////////////////////////////////////////////////////////////////////////

class CFontSizeSlider : public CSliderCtrl
{
private:
    int         m_TwipsMin;
    int         m_TwipsMax;
    int         m_nTwips;
    CBGBitmap  &m_bm;

public:
    CFontSizeSlider(CBGBitmap &bm);
    ~CFontSizeSlider();
    void SetTwipsRange(int TwipsMin, int TwipsMax);
    void SetTwips(int nTwips);
    int GetTwips();

    DECLARE_MESSAGE_MAP()
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnNMCustomdraw(NMHDR *pNMHDR, LRESULT *pResult);
};

///////////////////////////////////////////////////////////////////////////////////////////

class CFontListbox : public CListBox
{
public:
	CFontListbox();
	virtual ~CFontListbox();
    static int CALLBACK EnumFontFamProc(ENUMLOGFONT *lpelf, NEWTEXTMETRIC *lpntm,
					                    int nFontType, LPARAM lParam);
    void GetFontNames();
    bool SetSelFont(CString &strFont);
    CString GetSelFont();

protected:
	DECLARE_MESSAGE_MAP()
public:
    virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
};

///////////////////////////////////////////////////////////////////////////////////////////

class CFontSizeListbox : public CListBox
{
public:
	CFontSizeListbox();
	virtual ~CFontSizeListbox();
    void SetPt(int nPt);
    int GetPt();

protected:
	DECLARE_MESSAGE_MAP()

protected:
    virtual void PreSubclassWindow();

};


