#pragma once

///////////////////////////////////////////////////////////////////////////////////////////

class CTransparentCheckbox : public CButton
{
private:
    CBGBitmap &m_bm;

public:
    CTransparentCheckbox(CBGBitmap &bm);
    ~CTransparentCheckbox();

    DECLARE_MESSAGE_MAP()
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnNMCustomdraw(NMHDR *pNMHDR, LRESULT *pResult);
};

///////////////////////////////////////////////////////////////////////////////////////////

class CTransparentStatic : public CStatic
{
private:
    CBGBitmap &m_bm;

public:
    CTransparentStatic(CBGBitmap &bm);
    void SetWindowText(CString &strText);

    DECLARE_MESSAGE_MAP()
    afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
};

///////////////////////////////////////////////////////////////////////////////////////////

class CTransparentToolbar : public CToolBar
{
private:
    CBGBitmap &m_bm;
    CBitmap   m_bmTB;
    CBitmap   m_bmTBM;
    CImageList m_IconList;

    COLORREF GetState(int Index, int HotItem, int &state);

public:
	CTransparentToolbar(CBGBitmap &bm);
	virtual ~CTransparentToolbar();
    int Create(CWnd *pParent, int iID);

protected:
	DECLARE_MESSAGE_MAP()
public:
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnNcPaint();
    afx_msg void OnNMCustomdraw(NMHDR *pNMHDR, LRESULT *pResult);
    afx_msg void OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp);
    afx_msg void OnPaint();
};
